<div
  (dragover)="onDragOver($event)"
  (dragleave)="onDragLeave($event)"
  (drop)="onDrop($event)"
  class="dropfield"
  [class.drag-over]="isDragOver"
>
  <!-- Drag and Drop Instruction Text -->

  <div *ngIf="selectedFiles.length == 0">
    <h1>Drag and Drop Files Here</h1>
    <h1>or</h1>
  </div>

  <!-- File Upload Button -->
  <input
    #fileInput
    type="file"
    [accept]="acceptedDataTypes"
    multiple
    (change)="onFilesSelected($event)"
    style="display: none"
  />

  <!-- List of Selected Files -->
  <div class="table-container">
    <table
      mat-table
      [dataSource]="categorizedRows"
      class="mat-elevation-z8"
      *ngIf="categorizedRows.length > 0"
    >
      <!-- Column Definitions -->
      <ng-container
        *ngFor="let fileType of getObjectKeys(acceptedFileRegex)"
        matColumnDef="{{ fileType }}"
      >
        <th mat-header-cell *matHeaderCellDef>{{ fileType | uppercase }}</th>
        <td
          mat-cell
          *matCellDef="let row"
          (click)="
            row[fileType]
              ? toggleFileSelection(row[fileType].processedInfo.id, $event)
              : null
          "
          [class.selected]="
            row[fileType] && selectedFileIds.has(row[fileType].processedInfo.id)
          "
          [class.no-data]="!row[fileType]"
        >
          <div *ngIf="row[fileType]">
            {{ row[fileType].file.name }}
          </div>
          <div *ngIf="!row[fileType]" class="no-file">no file</div>
        </td>
      </ng-container>

      <!-- Header and Row Declarations -->
      <tr
        mat-header-row
        *matHeaderRowDef="getObjectKeys(acceptedFileRegex)"
      ></tr>
      <tr
        mat-row
        *matRowDef="let row; columns: getObjectKeys(acceptedFileRegex)"
      ></tr>
    </table>
  </div>

  <button
    mat-raised-button
    class="file-chooser-button"
    (click)="fileInput.click()"
  >
    <mat-icon>insert_drive_file </mat-icon> Choose Files
  </button>
  <div>Files must have an {{ acceptedDataTypes }} extension.</div>
</div>
<!-- Conditional Message for Missing Files -->
<div *ngIf="missingFiles && selectedFiles.length > 0">
  Files must be complete.
</div>

<button
  mat-raised-button
  color="primary"
  (click)="onUploadClick()"
  class="upload-button"
  [disabled]="missingFiles"
>
  <mat-icon>upload </mat-icon> Upload Files
</button>
